/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-08-09 20:59
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;

template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

// =============== Solution section ===============
const lf PI = acos(-1), EPSI = 1e-9;
// alread exist: lf abs(cp), norm(cp), cp polar(lf, lf), lf arg(cp), constants 0 + 1i
lf   dist   (cp a, cp b)       { return abs(a - b); }
lf   dot    (cp a, cp b)       { return real(conj(a) * b); }                // (commutative)
lf   cross  (cp a, cp b)       { return imag(conj(a) * b); }                // (anti-commutative)
lf   angle  (cp a, cp b, cp c) { return abs(arg((a - b) / (c - b))); }      // angle around b in [0, pi]
bool acute  (cp a, cp b, cp c) { return dot(a - b, c - b) > 0; }            // angle around b < 90d
bool obtuse (cp a, cp b, cp c) { return dot(a - b, c - b) < 0; }            // angle around b > 90d
bool cw     (cp a, cp b, cp c) { return cross(b - a, c - a) < 0; }          // a, b, c clockwise
bool ccw    (cp a, cp b, cp c) { return cross(b - a, c - a) > 0; }          // a, b, c counter-clockwise
bool col    (cp a, cp b, cp c) { return abs(cross(b - a, c - a)) < EPSI; }  // whether a, b, c on a line
// point distance functions
lf dist_line(cp a, cp b, cp p){ // line going through a and b
  return abs(dot(p - a, (b - a) * 1i)) / abs(b - a);
}
lf dist_ray(cp a, cp b, cp p){ // ray starting at a, through b
  return obtuse(b, a, p) ? dist(a, p) : dist_line(a, b, p);
}
lf dist_segment(cp a, cp b, cp p){ // segment from a to b
  return obtuse(a, b, p) ? dist(b, p) : dist_ray(a, b, p);
}
// return whether there is a unique intersect and if so, set p to the intersection
// these functions only work for non-parallel lines (they return 0 for parallel)!
bool intersect_lines(cp a1, cp d1, cp a2, cp d2, cp &p){
  if(cross(d1, d2) == 0) return 0;
  p = a1 + d1 * cross(a2 - a1, d2) / cross(d1, d2);
  return 1;
}
bool intersect_rays(cp a1, cp d1, cp a2, cp d2, cp &p){
  if(!intersect_lines(a1, d1, a2, d2, p)) return 0;
  return dot(p - a1, d1) >= 0 and dot(p - a2, d2) >= 0;
}
bool intersect_segments(cp a1, cp d1, cp a2, cp d2, cp &p){
  if(!intersect_lines(a1, d1, a2, d2, p)) return 0;
  lf l1 = dot(p - a1, d1) / norm(d1), l2 = dot(p - a2, d2) / norm(d2);
  return 0 <= l1 and l1 <= 1 and 0 <= l2 and l2 <= 1;
}

typedef vector<cp> poly;
auto pjc(cp &c){ return pair(imag(c), real(c)); };

// convex polygon from reference
lf pja(cp &x){ return arg(x); };
struct convex_poly {
  poly p;     // polygon (rotated)
  cp in;      // some point inside or on boundary
  // po must be convex polygon given in ccw order
  convex_poly(const poly &po, cp inp) : in(inp){
    for(auto &e : po) p.push_back(e - in);
    R::rotate(p, R::min_element(p, {}, pja));
  } // O(P)
  bool check_inside(cp pt){
    if(abs(pt -= in) < EPSI) return 1;
    auto it = R::lower_bound(p, arg(pt), {}, pja);
    if(it == begin(p) or it == end(p))
      return not ccw(p.back(), pt, p.front());
    else return not ccw(*(it - 1), pt, *it);
  } // O(log P)
};

// minkowski sum from reference

poly minkowski2(poly P, poly Q){
  R::rotate(P, R::min_element(P, {}, pjc));
  R::rotate(Q, R::min_element(Q, {}, pjc));
  poly res; res.reserve(size(P) + size(Q));
  P.push_back(P[0]), P.push_back(P[1]);
  Q.push_back(Q[0]), Q.push_back(Q[1]);
  size_t i = 0, j = 0;
  while(i < size(P) - 2 || j < size(Q) - 2){
    res.push_back(P[i] + Q[j]);
    lf c = cross(P[i + 1] - P[i],Q[j + 1] - Q[j]);
    if(c >= 0 && i < size(P) - 2) ++i;
    if(c <= 0 && j < size(Q) - 2) ++j;
  }
  return res;
}
/* lf mindist(poly P, poly Q){ // to be tested */
/*   for(cp &c : Q) c = -c; */
/*   poly res = minkowski2(P, Q); */
/*   convex_poly tmp(res, res[0]); */
/*   if(tmp.check_inside(cp(0, 0))) return 0; */
/*   lf ans = 1e100; */
/*   for(cp &v : res) ans = min(ans, abs(v)); */
/*   res.push_back(res[0]); */
/*   for(int i = 0; i < ssize(res) - 1; i++) */
/*     ans = min(ans, dist_segment(res[i], res[i + 1], cp(0, 0))); */
/*   return ans; */
/* } */


ll A, B, C, Q;
vector<cp> a, b, c, suitable;

void solve(){
    // Code goes here ...
    ll x, y;
    cin >> A;
    R(i, A){
        cin >> x >> y;
        a.emplace_back(x,y);
    }
    cin >> B;
    R(i, B){
        cin >> x >> y;
        b.emplace_back(x,y);
    }
    cin >> C;
    R(i, C){
        cin >> x >> y;
        c.emplace_back(x,y);
    }

    suitable = minkowski2(minkowski2(a,b), c);
    cp in = (suitable[0] + suitable[size(suitable) / 2] ) / 2.0;
    convex_poly suit (suitable, in);

    cin >> Q;
    R(i, Q){
        // check whether these coordinates are inside
        // the suitable area
        cin >> x >> y;
        cp z {3 * x, 3 * y};
        bool res = suit.check_inside(z);
        cout << (res ? "YES" : "NO") << endl;
    }
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    cout << setprecision(12); // << fixed;

    int T = 1;
    /* cin >> T; */
    while(T--)
        solve();

    return 0;
}
        
